#***********************************************************************
# Licensed Material - Property of IBM
#
# 
#
# (c) Copyright IBM Corp. 2009.  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#************************************************************************
##################################################################
#
# Deploys Telecom ICP ears.
#
# #######################################################################
import sys
import java
#########################################################################
# Load properties from file
#########################################################################
print
print "Reading configuration properties ..."
from java.util import Properties
from java.io import FileInputStream
from java.io import FileOutputStream
from java.io import OutputStreamWriter
from java.lang import System
from java.lang import Boolean
from java.lang import Integer
from java.lang import String
from java.lang import System
from com.ibm.wbimonitor.lifecycle.spi.mbeans import RESTSecurityAdminMBeanFactory

propFile = "config.properties"
fis = FileInputStream(propFile)
prop = Properties()
prop.load(fis)
print prop
#########################################################################
# Get Monitor Model and ear properties
#########################################################################
print
print "Loading Monitor Model configurations ..."
mmAppName = prop.getProperty('mmAppName')
mmEarFileName = prop.getProperty('mmEarFileName')

refEarAppNameOrder_TOCP_IPMP = prop.getProperty('refEarAppNameOrder_TOCP_IPMP')
refEarFileNameOrder_TOCP_IPMP = prop.getProperty('refEarFileNameOrder_TOCP_IPMP')

refEarAppNameOrder_TOCP_IPMMS = prop.getProperty('refEarAppNameOrder_TOCP_IPMMS')
refEarFileNameOrder_TOCP_IPMMS = prop.getProperty('refEarFileNameOrder_TOCP_IPMMS')

print "Configuration properties loaded."
#########################################################################
# Get User and Group properties
#########################################################################
print
print "Loading User and Group configurations ..."
groupName_CSR = prop.getProperty('groupName_CSR')
userName01 = prop.getProperty('userName01')
userName02 = prop.getProperty('userName02')
surName01 = prop.getProperty('surName01')
surName02 = prop.getProperty('surName02')
groupName_NOC = prop.getProperty('groupName_NOC')
userName03 = prop.getProperty('userName03')
userName04 = prop.getProperty('userName04')
surName03 = prop.getProperty('surName03')
surName04 = prop.getProperty('surName04')
groupName_Field = prop.getProperty('groupName_Field')
userName05 = prop.getProperty('userName05')
userName06 = prop.getProperty('userName06')
surName05 = prop.getProperty('surName05')
surName06 = prop.getProperty('surName06')
groupName_Manager = prop.getProperty('groupName_Manager')
userName07 = prop.getProperty('userName07')
surName07 = prop.getProperty('surName07')
#########################################################################
# Get connected cell/node/server name
#########################################################################
print
print "Reading server configuration ..."
cell = AdminControl.getCell();
print cell
node = AdminControl.getNode();
print node
wsadminServer =AdminControl.queryNames("node=" + node + ",type=Server,*" )
server = AdminControl.getAttribute(wsadminServer, "name" )
print server
#######################################################################
#
#
#########################################################################
# Get CEI configuration options
#########################################################################
print
print "Loading CEI configurations ..."

serverLocation = prop.getProperty('serverLocation')
hostName = prop.getProperty('hostName')
rmiPort = prop.getProperty('rmiPort')
soapPort = prop.getProperty('soapPort')
securityMode = prop.getProperty('securityMode')
userid = prop.getProperty('userid')
password = prop.getProperty('password')
eventGroup = prop.getProperty('eventGroup')
cellName = prop.getProperty('cellName')
nodeName = prop.getProperty('nodeName')
serverName = prop.getProperty('serverName')
clusterName = prop.getProperty('clusterName')
distributionMode = prop.getProperty('distributionMode')
createCubes = prop.getProperty('createCubes')
startCubes = prop.getProperty('startCubes')
businessSituation = prop.getProperty('businessSituation')
profileMigration = prop.getProperty('profileMigration')

#######################################################################
# Def - Uninstalling the Existing Application
#######################################################################

def unInstallApplications(appList):
    installedApps = AdminApp.list().splitlines()
    try:
        for app in appList:
            if(app in installedApps):
                print "Uninstalling "+ app
                AdminApp.uninstall(app)
		AdminConfig.save()
    except:
        print "Exception:Error while uninstalling "+ app
        sys.stderr.write("Exception:Error while uninstalling "+ app)
        raise
AdminConfig.save()
print "The order is: "     
fabricApplicationList = [refEarAppNameOrder_TOCP_IPMP, refEarAppNameOrder_TOCP_IPMMS, mmAppName]
print "The List of uninstallable: " + str(fabricApplicationList)
unInstallApplications(fabricApplicationList)
#########################################################################
# Creating user and group and their mapping
#########################################################################
print
print "Creating Group and user Name and their mapping ..."
try :
        
	attrGrp = ["-cn",groupName_CSR]
	if(len(AdminTask.searchGroups(attrGrp)) > 1):
	    print "Skipping creating group " +  groupName_CSR + " as group exists"
	else :
	    AdminTask.createGroup(attrGrp)
	attrName1 = ["-uid",userName03]
	if(len(AdminTask.searchUsers(attrName1)) > 1):
            print "Skipping creating user " +  userName01 + " as user exists"
	else :
	    appOptions = ["-uid", userName01, "-password", "password", "-confirmPassword", "password", "-cn", userName01, "-sn", surName01]
	    AdminTask.createUser(appOptions)
	    attrName1 = ["-uid",userName01]
	    userStr1 = AdminTask.searchUsers(attrName1)
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr1, "-groupUniqueName",groupStr]
 	    AdminTask.addMemberToGroup(appOptions)
	attrName2 = ["-uid",userName02]
	if(len(AdminTask.searchUsers(attrName2)) > 1):
            print "Skipping creating user " +  userName02 + " as user exists"
	else :
	    appOptions = ["-uid", userName02, "-password", "password", "-confirmPassword", "password", "-cn", userName02, "-sn", surName02]
	    AdminTask.createUser(appOptions)
	    attrName2 = ["-uid",userName02]
	    userStr2 =  AdminTask.searchUsers(attrName2)
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr2,"-groupUniqueName",groupStr ]
 	    AdminTask.addMemberToGroup(appOptions)

	attrGrp = ["-cn",groupName_NOC]
	if(len(AdminTask.searchGroups(attrGrp)) > 1):
	    print "Skipping creating group " +  groupName_NOC + " as group exists"
	else :
	    AdminTask.createGroup(attrGrp)
	attrName3 = ["-uid",userName03]
	if(len(AdminTask.searchUsers(attrName3)) > 1):
            print "Skipping creating user " +  userName03 + " as user exists"
	else :
	    appOptions = ["-uid", userName03, "-password", "password", "-confirmPassword", "password", "-cn", userName03, "-sn", surName03]
	    AdminTask.createUser(appOptions)
	    attrName3 = ["-uid",userName03]
	    userStr3 = AdminTask.searchUsers(attrName3)
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr3, "-groupUniqueName",groupStr]
 	    AdminTask.addMemberToGroup(appOptions)
	attrName4 = ["-uid",userName04]
	if(len(AdminTask.searchUsers(attrName4)) > 1):
            print "Skipping creating user " +  userName04 + " as user exists"
	else :
	    appOptions = ["-uid", userName04, "-password", "password", "-confirmPassword", "password", "-cn", userName04, "-sn", surName04]
	    AdminTask.createUser(appOptions)
	    attrName4 = ["-uid",userName04]
	    userStr4 =  AdminTask.searchUsers(attrName4)
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr4,"-groupUniqueName",groupStr ]
 	    AdminTask.addMemberToGroup(appOptions)

	attrGrp = ["-cn",groupName_Field]
	if(len(AdminTask.searchGroups(attrGrp)) > 1):
	    print "Skipping creating group " +  groupName_Field + " as group exists"
	else :
	    AdminTask.createGroup(attrGrp)
	attrName5 = ["-uid",userName05]
	if(len(AdminTask.searchUsers(attrName5)) > 1):
            print "Skipping creating user " +  userName05 + " as user exists"
	else :
	    appOptions = ["-uid", userName05, "-password", "password", "-confirmPassword", "password", "-cn", userName05, "-sn", surName05]
	    AdminTask.createUser(appOptions)
	    attrName5 = ["-uid",userName05]
	    userStr5 = AdminTask.searchUsers(attrName5)
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr5, "-groupUniqueName",groupStr]
 	    AdminTask.addMemberToGroup(appOptions)
	attrName6 = ["-uid",userName06]
	if(len(AdminTask.searchUsers(attrName6)) > 1):
            print "Skipping creating user " +  userName06 + " as user exists"
	else :
	    appOptions = ["-uid", userName06, "-password", "password", "-confirmPassword", "password", "-cn", userName06, "-sn", surName06]
	    AdminTask.createUser(appOptions)
	    attrName6 = ["-uid",userName06]
	    userStr6 =  AdminTask.searchUsers(attrName6)
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr6,"-groupUniqueName",groupStr ]
 	    AdminTask.addMemberToGroup(appOptions)

	attrGrp = ["-cn",groupName_Manager]
	if(len(AdminTask.searchGroups(attrGrp)) > 1):
	    print "Skipping creating group " +  groupName_Manager + " as group exists"
	else :
	    AdminTask.createGroup(attrGrp)
	attrName7 = ["-uid",userName07]
	if(len(AdminTask.searchUsers(attrName7)) > 1):
            print "Skipping creating user " +  userName07 + " as user exists"
	else :
	    appOptions = ["-uid", userName07, "-password", "password", "-confirmPassword", "password", "-cn", userName07, "-sn", surName07]
	    AdminTask.createUser(appOptions)
	    attrName7 = ["-uid",userName07]
	    userStr7 = AdminTask.searchUsers(attrName7)
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr7, "-groupUniqueName",groupStr]
 	    AdminTask.addMemberToGroup(appOptions)
		
except :
        print "Exception:Error occured while Group user creation and mapping"
        sys.stderr.write("Error occured while Group user creation and mapping")
        raise
        print "Group groupName"

#########################################################################
# Creating user and group and their mapping done
#########################################################################
#Deploy the Telecom application
#########################################################################
# Install Ref app EAR
#########################################################################
print
print "Installing Reference Implementation application ... " + refEarAppNameOrder_TOCP_IPMP
try :
        appOptions = ["-appname", refEarAppNameOrder_TOCP_IPMP, "-server", serverName]
	AdminApp.install(refEarFileNameOrder_TOCP_IPMP, appOptions)

except :
        print "Exception:Error occured while deploying refEarAppNameOrder_TOCP_IPMP"
        sys.stderr.write("Error occured while deploying refEarAppNameOrder_TOCP_IPMP")
        raise
       
# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', refEarAppNameOrder_TOCP_IPMP)
print "Ear started: " + refEarAppNameOrder_TOCP_IPMP
print refEarAppNameOrder_TOCP_IPMP + " installed successfully."

print "Installing EAR application ... " + refEarAppNameOrder_TOCP_IPMMS
try :
        appOptions = ["-appname", refEarAppNameOrder_TOCP_IPMMS, "-server", serverName]
	AdminApp.install(refEarFileNameOrder_TOCP_IPMMS, appOptions)

except :
        print "Exception:Error occured while deploying refEarAppNameOrder_TOCP_IPMMS"
        sys.stderr.write("Error occured while deploying refEarAppNameOrder_TOCP_IPMMS")
        raise
        
# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', refEarAppNameOrder_TOCP_IPMMS)
print "Ear started: " + refEarAppNameOrder_TOCP_IPMMS
print refEarAppNameOrder_TOCP_IPMMS + " installed successfully."

#########################################################################
# Install Monitor Model EARs
#########################################################################
print
print "Installing Monitor Model application ..."

# The LifecycleClientDatabaseTask task consists of the following 6 fields
# and the acceptable values:
#   "Run scripts to create the schema" = yes or no
#   "Run scripts to enable Data Movement Services" = yes or no
#   "Run scripts to delete the schema during uninstallation" = yes or no
#   "Processing strategy" = SerialST or SerialMT
#   "Enable event reordering" = yes or no
#   "Enable KPI merge from previous version" = yes or no
createSchema = 'yes'
enableDMS = 'no'
deleteSchema = 'yes'
processingStrategy = 'SerialMT'
eventReordering = 'no'
kpiMerge = 'no'
businessSituation = 'yes'
profileMigration = 'no'

 # Alphablox settings

 # 1.  The LifecycleClientAlphabloxTask task consists of the following 8 fields
 # 2. and the acceptable values:
 # 3. "Server location (local/remote)" = local or remote
 # 4. default is local
 # 5. "Host name, ignored if location is local"= hostname
 # 6. "RMI port, ignored if location is local" = port number
 # 7. "Security (enabled/disabled), ignored if location is local" = enabled or disabled
 # 8. default is disabled
 # 9. "User ID, ignored if security is disabled" = user ID
 # 10. "Password, ignored if security is disabled" = password
 # 11. "Create the Alphablox cubes" = yes or no
 # 12. default is yes if Alphablox is local
 # 13. "Start the Alphablox cubes" = should be the same value as "Create the Alphablox cubes"
serverLocation = 'local'
hostName = ''
rmiPort = ''
securityMode = 'enabled'
userid = 'admin'
password = 'admin'
createCubes = 'yes'
startCubes = 'yes'

databaseTaskInfo = [ createSchema, enableDMS, deleteSchema, processingStrategy, eventReordering, kpiMerge, businessSituation, profileMigration ]
alphabloxTaskInfo = [ serverLocation, hostName, rmiPort, securityMode, userid, password, createCubes, startCubes ]

print AdminControl.trace('com.ibm.wbimonitor.*=all=enabled')

print
print "Installing Monitor Model application ..."
# Install Monitor Model EAR
if serverLocation == 'local':
   cellName = cell
   nodeName = node
   serverName = server
elif serverLocation == 'remote':
   print "Installing Monitor Model on remote Monitor server..." 
else:
   print "Please set CEI server location in configration properties file"
   sys.exit(1)

ceiTaskInfo = [ serverLocation, hostName, rmiPort, securityMode, userid, password, \
   eventGroup, cellName, nodeName, serverName, clusterName, distributionMode ]
try :
	AdminApp.install(mmEarFileName,  ['-LifecycleClientDatabaseTask', [databaseTaskInfo], \
	'-LifecycleClientAlphabloxTask', [alphabloxTaskInfo], \
	'-LifecycleClientCEITask', [ceiTaskInfo], '-appname', mmAppName]  )

except :
        print "Exception:Error occured while deploying mmAppName"
        sys.stderr.write("Error occured while deploying mmAppName")
        raise
        print "Deployed Monitor Model ears."

# Save the app
AdminConfig.save()
appManager = AdminControl.queryNames('type=ApplicationManager,*')
print "The appManager is: " + appManager
AdminControl.invoke(appManager, 'startApplication', mmAppName)
print "Ear started: " + mmAppName
print mmAppName + " installed successfully."

#########################################################################
# Monitor Model Role Mapping begins.
#########################################################################

AdminControl.trace( 'com.ibm.wbimonitor.*=all=enabled' )  

rest_mbean = RESTSecurityAdminMBeanFactory.getMBean( AdminControl.getAdminClient() )
print 'RESTSecurityAdminMBean.toString=' + rest_mbean.toString()

#The return type is a boolean 'true' or 'false'


result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName01 + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName01 + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName01 + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName01 + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName01 + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName01 + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName01+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName01 + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName01 + "to role KPI-Administrator"



result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName02 + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName02 + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName02 + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName02 + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName02 + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName02 + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName02+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName02 + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName02 + "to role KPI-Administrator"


result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName03 + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName03 + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName03 + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName03 + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName03 + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName03 + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName03+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName03 + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName03 + "to role KPI-Administrator"



result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName04 + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName04 + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName04 + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName04 + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName04 + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName04 + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName04+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName04 + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName04 + "to role KPI-Administrator"


result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName05+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName05 + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName05 + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName05+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName05 + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName05 + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName05+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName05 + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName05 + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName05+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName05 + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName05 + "to role KPI-Administrator"



result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName06+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName06 + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName06 + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName06+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName06 + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName06 + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName06+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName06 + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName06 + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName06+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName06 + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName06 + "to role KPI-Administrator"



result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName07+",o=defaultWIMFileBasedRealm","root","Business-Manager","user")
if (result==1) :
    print "User "+ userName07 + "successfully mapped to role Business-Manager" 
else :
    print "Failed to map user " + userName07 + "to role Business-Manager"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName07+",o=defaultWIMFileBasedRealm","root","Personal-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName07 + "successfully mapped to role Personal-KPI-Administrator" 
else :
    print "Failed to map user " + userName07 + "to role Personal-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName07+",o=defaultWIMFileBasedRealm","root","Public-KPI-Administrator","user")
if (result==1) :
    print "User "+ userName07 + "successfully mapped to role Public-KPI-Administrator" 
else :
    print "Failed to map user " + userName07 + "to role Public-KPI-Administrator"

result = rest_mbean.assignRoleToUserOnResourceGroup("uid="+userName07+",o=defaultWIMFileBasedRealm","root","KPI-Administrator","user")
if (result==1) :
    print "User "+ userName07 + "successfully mapped to role KPI-Administrator" 
else :
    print "Failed to map user " + userName07 + "to role KPI-Administrator"
#########################################################################
# Monitor Model Role Mapping is done.
#########################################################################
#######################################################################
# #Save configuration
#######################################################################
AdminConfig.save()
print "All the configurations are saved .."