#***********************************************************************
# Licensed Material - Property of IBM
#
# 
#
# (c) Copyright IBM Corp. 2009.  All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#************************************************************************
##################################################################
#
# Uninstalls Telecom ICP ears.
#
# #######################################################################
import sys
import java
#########################################################################
# Load properties from file
#########################################################################
print
print "Reading configuration properties ..."
from java.util import Properties
from java.io import FileInputStream
from java.io import FileOutputStream
from java.io import OutputStreamWriter
from java.lang import System
from java.lang import Boolean
from java.lang import Integer
from java.lang import String
from com.ibm.wbimonitor.lifecycle.spi.mbeans import RESTSecurityAdminMBeanFactory

propFile = "config.properties"
fis = FileInputStream(propFile)
prop = Properties()
prop.load(fis)
print prop
#########################################################################
# Get Monitor Model and ear properties
#########################################################################
print
print "Loading Monitor Model configurations ..."
mmAppName = prop.getProperty('mmAppName')
mmEarFileName = prop.getProperty('mmEarFileName')

refEarAppNameOrder_TOCP_IPMP = prop.getProperty('refEarAppNameOrder_TOCP_IPMP')
refEarFileNameOrder_TOCP_IPMP = prop.getProperty('refEarFileNameOrder_TOCP_IPMP')

refEarAppNameOrder_TOCP_IPMMS = prop.getProperty('refEarAppNameOrder_TOCP_IPMMS')
refEarFileNameOrder_TOCP_IPMMS = prop.getProperty('refEarFileNameOrder_TOCP_IPMMS')

print "Configuration properties loaded."
#########################################################################
# Get User and Group properties
#########################################################################
print
print "Loading User and Group configurations ..."
groupName_CSR = prop.getProperty('groupName_CSR')
userName01 = prop.getProperty('userName01')
userName02 = prop.getProperty('userName02')
surName01 = prop.getProperty('surName01')
surName02 = prop.getProperty('surName02')
groupName_NOC = prop.getProperty('groupName_NOC')
userName03 = prop.getProperty('userName03')
userName04 = prop.getProperty('userName04')
surName03 = prop.getProperty('surName03')
surName04 = prop.getProperty('surName04')
groupName_Field = prop.getProperty('groupName_Field')
userName05 = prop.getProperty('userName05')
userName06 = prop.getProperty('userName06')
surName05 = prop.getProperty('surName05')
surName06 = prop.getProperty('surName06')
groupName_Manager = prop.getProperty('groupName_Manager')
userName07 = prop.getProperty('userName07')
surName07 = prop.getProperty('surName07')
#########################################################################
# Get connected cell/node/server name
#########################################################################
print
print "Reading server configuration ..."
cell = AdminControl.getCell();
print cell
node = AdminControl.getNode();
print node
wsadminServer =AdminControl.queryNames("node=" + node + ",type=Server,*" )
server = AdminControl.getAttribute(wsadminServer, "name" )
print server
#######################################################################
#
#
#########################################################################
# Get CEI configuration options
#########################################################################
print
print "Loading CEI configurations ..."

serverLocation = prop.getProperty('serverLocation')
hostName = prop.getProperty('hostName')
rmiPort = prop.getProperty('rmiPort')
soapPort = prop.getProperty('soapPort')
securityMode = prop.getProperty('securityMode')
userid = prop.getProperty('userid')
password = prop.getProperty('password')
eventGroup = prop.getProperty('eventGroup')
cellName = prop.getProperty('cellName')
nodeName = prop.getProperty('nodeName')
serverName = prop.getProperty('serverName')
clusterName = prop.getProperty('clusterName')
distributionMode = prop.getProperty('distributionMode')

#######################################################################
# Def - Uninstalling the Existing Application
#######################################################################

def unInstallApplications(appList):
    installedApps = AdminApp.list().splitlines()
    try:
        for app in appList:
            if(app in installedApps):
                print "Uninstalling "+ app
                AdminApp.uninstall(app)
		AdminConfig.save()
    except:
        print "Exception:Error while uninstalling "+ app
        sys.stderr.write("Exception:Error while uninstalling "+ app)
        raise
AdminConfig.save()
print "The order is: "     
fabricApplicationList = [refEarAppNameOrder_TOCP_IPMP, refEarAppNameOrder_TOCP_IPMMS, mmAppName]
print "The List of uninstallable: " + str(fabricApplicationList)
unInstallApplications(fabricApplicationList)
#########################################################################
# Deleting users, groups and their mapping
#########################################################################
print
print "Deleting users, groups and their mapping ..."
try :
	attrName1 = ["-uid",userName01]
	if(len(AdminTask.searchUsers(attrName1)) > 1):
	    print "Deleting user " +  userName01
	    userStr1 =  AdminTask.searchUsers(attrName1)
	    attrGrp = ["-cn",groupName_CSR]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr1,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member "  +  userName01 + " from group"
	    appOptions = ["-uniqueName", userStr1]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName01
	    
	else :
	    print "User " + userName01 + " does not exist" 

	attrName2 = ["-uid",userName02]
	if(len(AdminTask.searchUsers(attrName2)) > 1):
	    print "Deleting user " +  userName02
	    userStr2 =  AdminTask.searchUsers(attrName2)
	    attrGrp = ["-cn",groupName_CSR]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr2,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member " + userName02 + " from group"
	    appOptions = ["-uniqueName", userStr2]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName02
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupName_CSR
	else :
	    print "User " + userName02 + " does not exist"

	attrName3 = ["-uid",userName03]
	if(len(AdminTask.searchUsers(attrName3)) > 1):
	    print "Deleting user " +  userName03
	    userStr3 =  AdminTask.searchUsers(attrName3)
	    attrGrp = ["-cn",groupName_NOC]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr3,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member "  +  userName03 + " from group"
	    appOptions = ["-uniqueName", userStr3]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName03
	    
	else :
	    print "User " + userName03 + " does not exist" 

	attrName4 = ["-uid",userName04]
	if(len(AdminTask.searchUsers(attrName4)) > 1):
	    print "Deleting user " +  userName04
	    userStr4 =  AdminTask.searchUsers(attrName4)
	    attrGrp = ["-cn",groupName_NOC]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr4,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member " + userName04 + " from group"
	    appOptions = ["-uniqueName", userStr4]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName04
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupName_NOC
	else :
	    print "User " + userName04 + " does not exist"

	attrName5 = ["-uid",userName05]
	if(len(AdminTask.searchUsers(attrName5)) > 1):
	    print "Deleting user " +  userName05
	    userStr5 =  AdminTask.searchUsers(attrName5)
	    attrGrp = ["-cn",groupName_Field]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr5,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member "  +  userName05 + " from group"
	    appOptions = ["-uniqueName", userStr5]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName05
	    
	else :
	    print "User " + userName05 + " does not exist" 

	attrName6 = ["-uid",userName06]
	if(len(AdminTask.searchUsers(attrName6)) > 1):
	    print "Deleting user " +  userName06
	    userStr6 =  AdminTask.searchUsers(attrName6)
	    attrGrp = ["-cn",groupName_Field]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr6,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member " + userName06 + " from group"
	    appOptions = ["-uniqueName", userStr6]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName06
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupName_Field
	else :
	    print "User " + userName06 + " does not exist"

	attrName7 = ["-uid",userName07]
	if(len(AdminTask.searchUsers(attrName7)) > 1):
	    print "Deleting user " +  userName07
	    userStr7 =  AdminTask.searchUsers(attrName7)
	    attrGrp = ["-cn",groupName_Manager]
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-memberUniqueName", userStr7,"-groupUniqueName",groupStr ]
	    AdminTask.removeMemberFromGroup(appOptions)
	    print "Removed member " + userName07 + " from group"
	    appOptions = ["-uniqueName", userStr7]
	    AdminTask.deleteUser(appOptions)
	    print "Deleted user " +  userName07
	    groupStr = AdminTask.searchGroups(attrGrp)
	    appOptions = ["-uniqueName",groupStr ]
	    AdminTask.deleteGroup(appOptions)
	    print "Deleted group " +  groupName_Manager
	else :
	    print "User " + userName07 + " does not exist"

except :
        print "Exception:Error occured while deleting users, groups and their mapping "
        sys.stderr.write("Error occured while deleting users, groups and their mapping ")
        raise
#########################################################################
# Monitor Model Role Mapping removal begins.
#########################################################################

AdminControl.trace( 'com.ibm.wbimonitor.*=all=enabled' )  

rest_mbean = RESTSecurityAdminMBeanFactory.getMBean( AdminControl.getAdminClient() )
print 'RESTSecurityAdminMBean.toString=' + rest_mbean.toString()

#The return type is a boolean 'true' or 'false'


result = rest_mbean.removeRole("uid="+userName01+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName01 + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName01 + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName01+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName01 + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName01 + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName01+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName01 + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName01 + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName01+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName01 + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName01 + "to role KPI-Administrator"



result = rest_mbean.removeRole("uid="+userName02+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName02 + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName02 + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName02+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02 + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02 + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName02+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02 + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02 + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName02+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName02 + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName02 + "to role KPI-Administrator"



result = rest_mbean.removeRole("uid="+userName03+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName03 + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName03 + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName03+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName03 + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName03 + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName03+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName03 + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName03 + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName03+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName03 + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName03 + "to role KPI-Administrator"



result = rest_mbean.removeRole("uid="+userName04+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName04 + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName04 + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName04+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName04 + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName04 + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName04+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName04 + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName04 + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName04+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName04 + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName04 + "to role KPI-Administrator"


result = rest_mbean.removeRole("uid="+userName05+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName05 + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName05 + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName05+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName05 + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName05 + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName05+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName05 + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName05 + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName05+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName05 + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName05 + "to role KPI-Administrator"



result = rest_mbean.removeRole("uid="+userName06+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName06 + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName06 + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName06+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName06 + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName06 + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName06+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName06 + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName06 + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName06+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName06 + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName06 + "to role KPI-Administrator"



result = rest_mbean.removeRole("uid="+userName07+",o=defaultWIMFileBasedRealm","Business-Manager","root")
if (result==1) :
    print "User "+ userName07 + "successfully unmapped from role Business-Manager" 
else :
    print "Failed to unmap user " + userName07 + "to role Business-Manager"

result = rest_mbean.removeRole("uid="+userName07+",o=defaultWIMFileBasedRealm","Personal-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName07 + "successfully unmapped from role Personal-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName07 + "to role Personal-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName07+",o=defaultWIMFileBasedRealm","Public-KPI-Administrator","root")
if (result==1) :
    print "User "+ userName07 + "successfully unmapped from role Public-KPI-Administrator" 
else :
    print "Failed to unmap user " + userName07 + "to role Public-KPI-Administrator"

result = rest_mbean.removeRole("uid="+userName07+",o=defaultWIMFileBasedRealm","KPI-Administrator","root")
if (result==1) :
    print "User "+ userName07 + "successfully unmapped from role KPI-Administrator" 
else :
    print "Failed to unmap user " + userName07 + "to role KPI-Administrator"
#########################################################################
# Monitor Model Role Mapping removed.
#########################################################################
        	
AdminConfig.save()